#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <allegro.h>

#define MAX_X		800
#define MAX_Y		600
#define V_MAX_X		0
#define V_MAX_Y		0
#define COLOR_BITS	32

#define tile_xy 48
#define button_xy 17
#define aba_x 60
#define aba_y 25
#define menu_button_xy 45


// Vetores das Paletas
BITMAP **tiles,
       **lower,
       **objects,
       **upper,
       **uppest,

// Bitmaps da Tela
	   *buffer,
	   *map_buffer,
       *frame,
	   *intro,

// Bitmaps de Interface
	   *right_button_p,
	   *right_button_unp,
	   *left_button_p,
	   *left_button_unp,
	   *up_button_p,
	   *up_button_unp,
	   *down_button_p,
	   *down_button_unp,

	   *bar_ud,
	   *bar_lr,

	   *cursor,
	   *mouse,

	   *aba_tiles_p,
	   *aba_tiles_unp,
	   *aba_lower_p,
	   *aba_lower_unp,
	   *aba_objects_p,
	   *aba_objects_unp,
	   *aba_upper_p,
	   *aba_upper_unp,
	   *aba_uppest_p,
	   *aba_uppest_unp,

	   *menu_save,
	   *menu_load,
	   *menu_help,
	   *menu_new,
	   *menu_exit,

	   *save_box,
	   *load_box,
	   *resize_box,
	   *confirm_box;

// Matriz Variavel de Inteiros do Mapa Atual
int **map_tiles,
	**map_lower,
	**map_objects,
	**map_upper,
	**map_uppest,

// Tamanho das Paletas
	tam_tiles,
	tam_lower,
	tam_objects,
	tam_upper,
	tam_uppest,

	barra_paleta,
	aba,
	barra_map_ud,
	barra_map_lr,

	map_x,
	map_y,

	sair,

	selected;

FILE *parq;

char *nome,
	 letras[50];

// Funes Bsicas
int inicia (void);
void principal (void);
void finaliza (void);
int get_name (int);

// Funes de Image Load
void load_tiles (void);
void load_lower (void);
void load_objects (void);
void load_upper (void);
void load_uppest (void);
void load_interface (void);

// Funes de Mapa
void new_map (int,int);
void load_map (void);
void save_map (void);
void resize_map (void);

// Funes de Impresso
void draw_pallete (void);
void draw_map (void);
void draw (void);
void draw_aba (void);

// Funes de Interface
void barra_pressed (void);
void move_cursor (void);
void select_aba (void);
void menu_pressed (void);

int main (void)
{
	if (!inicia())
	{
		finaliza();
		return -1;
	}

	principal();

	finaliza();

	return 0;
}
END_OF_MAIN();

// Funes ---------------------------------------------
void principal (void)
{
	// Setando
	barra_paleta = 0;
	barra_map_ud = 0;
	barra_map_lr = 0;
	aba = 0;
	selected = 0;
	sair = 0;

	//text_mode(makecol(0,0,0));

	nome ="maps/map00.map";

	// Carregando Imagens e Criando Bitmaps
	buffer = create_bitmap(MAX_X,MAX_Y);
	clear_to_color(buffer,makecol(255,0,255));

	load_tiles();
	load_lower();
	load_objects();
	load_upper();
	load_uppest();

	load_interface();

	// Criando as Matrizes dos Mapas
	map_x = 10;
	map_y = 10;

	// Criando o Mapa
	new_map(map_x,map_y);

	// Criando o Buffer para o mapa
	map_buffer = create_bitmap((tile_xy * map_x),(tile_xy * map_y));

	blit(intro,screen,0,0,0,0,MAX_X,MAX_Y);
	while(!keypressed()){}

	while (!sair)
	{
		//Testa abas
		select_aba();

		clear_to_color(buffer,makecol(255,0,255));
		clear_to_color(map_buffer,makecol(255,0,255));

		// Desenha Paleta no Frame
		draw_pallete();

		// Desenha o Frame
		draw_sprite(buffer,frame,0,0);

		// Testa Butaoes e Desenha no Buffer
		barra_pressed();
		menu_pressed();
		move_cursor();
		draw();

		// Desenha Mapa no Buffer do Mapa
		draw_map();

		// Desenha Interface
		draw_aba();

		// Desenha Cursor no Buffer
		if ((selected >= (5 * barra_paleta)) && (selected < ((5 * barra_paleta) + 50)))
		{
			draw_sprite(buffer,cursor,(MAX_X - (tile_xy * (5 - (selected % 5)))) - 17,tile_xy * (((int)(selected / 5)) - barra_paleta));
		}

		// Blita Buffer do Mapa
		blit(map_buffer,buffer,(tile_xy * barra_map_lr),(tile_xy * barra_map_ud),0,0,480,480);

		// Desenha Mouse
		draw_sprite(buffer,mouse,mouse_x - 11,mouse_y);

		// Blita Buffer
		blit(buffer,screen,0,0,0,0,MAX_X,MAX_Y);
	}
}

void finaliza (void)
{
	allegro_exit();
}

void load_tiles (void)
{
	char arquivo[50],
		 *temp;
	int total = 0,
	    i;

	tiles = (BITMAP **)malloc(sizeof(BITMAP *)*(total + 2));


	temp = "sprites/map/tiles/grass01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		tiles[total] = load_bitmap(arquivo,NULL);

		if (tiles[total] != NULL)
		{
			tiles = (BITMAP **)realloc(tiles,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (tiles[total] != NULL);
	total--;

	temp = "sprites/map/tiles/dirt01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		tiles[total] = load_bitmap(arquivo,NULL);

		if (tiles[total] != NULL)
		{
			tiles = (BITMAP **)realloc(tiles,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (tiles[total] != NULL);
	total--;

	temp = "sprites/map/tiles/carpet01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		tiles[total] = load_bitmap(arquivo,NULL);

		if (tiles[total] != NULL)
		{
			tiles = (BITMAP **)realloc(tiles,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (tiles[total] != NULL);
	total--;

	temp = "sprites/map/tiles/bridge01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		tiles[total] = load_bitmap(arquivo,NULL);

		if (tiles[total] != NULL)
		{
			tiles = (BITMAP **)realloc(tiles,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (tiles[total] != NULL);
	total--;

	temp = "sprites/map/tiles/stairs01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		tiles[total] = load_bitmap(arquivo,NULL);

		if (tiles[total] != NULL)
		{
			tiles = (BITMAP **)realloc(tiles,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (tiles[total] != NULL);
	total--;

	temp = "sprites/map/tiles/floor01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		tiles[total] = load_bitmap(arquivo,NULL);

		if (tiles[total] != NULL)
		{
			tiles = (BITMAP **)realloc(tiles,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (tiles[total] != NULL);
	total--;

	tam_tiles = total + 1;

	for (i = 0; i <= (total + 1); i++)
	{
		if (tiles[i] != NULL)
		{
			printf("tiles[%d]: Bitmap carregado\n",i);
		}
		else
		{
			printf("tiles[%d]: Bitmap Nao Existe\n",i);
		}
	}
	printf("%d = (Tiles Carregados + 1)\n",tam_tiles);
}

void load_lower (void)
{
	char arquivo[50],
		 *temp;
	int total = 0,
	    i;

	lower = (BITMAP **)malloc(sizeof(BITMAP *)*(total + 2));

	temp = "sprites/map/lower/furniture01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		lower[total] = load_bitmap(arquivo,NULL);

		if (lower[total] != NULL)
		{
			lower = (BITMAP **)realloc(lower,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (lower[total] != NULL);
	total--;

	tam_lower = total + 1;

	for (i = 0; i <= (total + 1); i++)
	{
		if (lower[i] != NULL)
		{
			printf("lower[%d]: Bitmap carregado\n",i);
		}
		else
		{
			printf("lower[%d]: Bitmap Nao Existe\n",i);
		}
	}
	printf("%d = (lower Carregados + 1)\n",tam_lower);
}

void load_objects (void)
{
	char arquivo[50],
		 *temp;
	int total = 0,
	    i;

	objects = (BITMAP **)malloc(sizeof(BITMAP *)*(total + 2));

	temp = "sprites/map/objects/door01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		objects[total] = load_bitmap(arquivo,NULL);

		if (objects[total] != NULL)
		{
			objects = (BITMAP **)realloc(objects,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (objects[total] != NULL);
	total--;

	temp = "sprites/map/objects/furniture01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		objects[total] = load_bitmap(arquivo,NULL);

		if (objects[total] != NULL)
		{
			objects = (BITMAP **)realloc(objects,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (objects[total] != NULL);
	total--;

	temp = "sprites/map/objects/plant01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		objects[total] = load_bitmap(arquivo,NULL);

		if (objects[total] != NULL)
		{
			objects = (BITMAP **)realloc(objects,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (objects[total] != NULL);
	total--;

	temp = "sprites/map/objects/upper01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		objects[total] = load_bitmap(arquivo,NULL);

		if (objects[total] != NULL)
		{
			objects = (BITMAP **)realloc(objects,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (objects[total] != NULL);
	total--;

	temp = "sprites/map/objects/wall01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		objects[total] = load_bitmap(arquivo,NULL);

		if (objects[total] != NULL)
		{
			objects = (BITMAP **)realloc(objects,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (objects[total] != NULL);
	total--;

	temp = "sprites/map/objects/well01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		objects[total] = load_bitmap(arquivo,NULL);

		if (objects[total] != NULL)
		{
			objects = (BITMAP **)realloc(objects,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (objects[total] != NULL);
	total--;

	temp = "sprites/map/objects/window01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		objects[total] = load_bitmap(arquivo,NULL);

		if (objects[total] != NULL)
		{
			objects = (BITMAP **)realloc(objects,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (objects[total] != NULL);
	total--;

	tam_objects = total + 1;

	for (i = 0; i <= (total + 1); i++)
	{
		if (objects[i] != NULL)
		{
			printf("objects[%d]: Bitmap carregado\n",i);
		}
		else
		{
			printf("objects[%d]: Bitmap Nao Existe\n",i);
		}
	}
	printf("%d = (objects Carregados + 1)\n",tam_objects);
}

void load_upper (void)
{
	char arquivo[50],
		 *temp;
	int total = 0,
	    i;

	upper = (BITMAP **)malloc(sizeof(BITMAP *)*(total + 2));

	temp = "sprites/map/upper/furniture01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		upper[total] = load_bitmap(arquivo,NULL);

		if (upper[total] != NULL)
		{
			upper = (BITMAP **)realloc(upper,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (upper[total] != NULL);
	total--;

	temp = "sprites/map/upper/plant01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		upper[total] = load_bitmap(arquivo,NULL);

		if (upper[total] != NULL)
		{
			upper = (BITMAP **)realloc(upper,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (upper[total] != NULL);
	total--;

	temp = "sprites/map/upper/roof01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		upper[total] = load_bitmap(arquivo,NULL);

		if (upper[total] != NULL)
		{
			upper = (BITMAP **)realloc(upper,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (upper[total] != NULL);
	total--;

	temp = "sprites/map/upper/wall01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		upper[total] = load_bitmap(arquivo,NULL);

		if (upper[total] != NULL)
		{
			upper = (BITMAP **)realloc(upper,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (upper[total] != NULL);
	total--;

	temp = "sprites/map/upper/window01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		upper[total] = load_bitmap(arquivo,NULL);

		if (upper[total] != NULL)
		{
			upper = (BITMAP **)realloc(upper,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (upper[total] != NULL);
	total--;

	tam_upper = total + 1;

	for (i = 0; i <= (total + 1); i++)
	{
		if (upper[i] != NULL)
		{
			printf("upper[%d]: Bitmap carregado\n",i);
		}
		else
		{
			printf("upper[%d]: Bitmap Nao Existe\n",i);
		}
	}
	printf("%d = (upper Carregados + 1)\n",tam_upper);
}

void load_uppest (void)
{
	char arquivo[50],
		 *temp;
	int total = 0,
	    i;

	uppest = (BITMAP **)malloc(sizeof(BITMAP *)*(total + 2));

	temp = "sprites/map/uppest/cross01.bmp";
	strcpy(arquivo,temp);

	printf("\nTamanho do nome do arquivo: %d\n",strlen(arquivo));
	printf("Nome do Arquivo = %s\n\n",arquivo);

	do
	{
		total++;

		uppest[total] = load_bitmap(arquivo,NULL);

		if (uppest[total] != NULL)
		{
			uppest = (BITMAP **)realloc(uppest,sizeof(BITMAP *)*(total + 2));

			if (arquivo[strlen(arquivo) - 5] < '9')
			{
				arquivo[strlen(arquivo) - 5]++;
			}
			else if (arquivo [strlen(arquivo) - 5] == '9')
			{
				arquivo[strlen(arquivo) - 5] = '0';
				arquivo[strlen(arquivo) - 6]++;
			}
		}
	}
	while (uppest[total] != NULL);
	total--;

	tam_uppest = total + 1;

	for (i = 0; i <= (total + 1); i++)
	{
		if (uppest[i] != NULL)
		{
			printf("uppest[%d]: Bitmap carregado\n",i);
		}
		else
		{
			printf("uppest[%d]: Bitmap Nao Existe\n",i);
		}
	}
	printf("%d = (uppest Carregados + 1)\n",tam_uppest);
}

void draw_pallete (void)
{
	int i;

	//Desenha Paleta no Buffer
	if (aba == 0)
	{
		if (barra_paleta != 0)
		{
			for (i = (barra_paleta * 5); i < tam_tiles; i++)
			{
				draw_sprite(buffer,tiles[i],(MAX_X - (tile_xy * (5 - (i % 5)))) - 17,tile_xy * (((int)(i / 5)) - barra_paleta));
			}
		}
		else
		{
			for (i = 1; i < tam_tiles; i++)
			{
				draw_sprite(buffer,tiles[i],(MAX_X - (tile_xy * (5 - (i % 5)))) - 17,tile_xy * ((int)(i / 5)));
			}
		}
	}
	else if (aba == 1)
	{
		if (barra_paleta != 0)
		{
			for (i = (barra_paleta * 5); i < tam_lower; i++)
			{
				draw_sprite(buffer,lower[i],(MAX_X - (tile_xy * (5 - (i % 5)))) - 17,tile_xy * (((int)(i / 5)) - barra_paleta));
			}
		}
		else
		{
			for (i = 1; i < tam_lower; i++)
			{
				draw_sprite(buffer,lower[i],(MAX_X - (tile_xy * (5 - (i % 5)))) - 17,tile_xy * ((int)(i / 5)));
			}
		}
	}
	else if (aba == 2)
	{
		if (barra_paleta != 0)
		{
			for (i = (barra_paleta * 5); i < tam_objects; i++)
			{
				draw_sprite(buffer,objects[i],(MAX_X - (tile_xy * (5 - (i % 5)))) - 17,tile_xy * (((int)(i / 5)) - barra_paleta));
			}
		}
		else
		{
			for (i = 1; i < tam_objects; i++)
			{
				draw_sprite(buffer,objects[i],(MAX_X - (tile_xy * (5 - (i % 5)))) - 17,tile_xy * ((int)(i / 5)));
			}
		}
	}
	else if (aba == 3)
	{
		if (barra_paleta != 0)
		{
			for (i = (barra_paleta * 5); i < tam_upper; i++)
			{
				draw_sprite(buffer,upper[i],(MAX_X - (tile_xy * (5 - (i % 5)))) - 17,tile_xy * (((int)(i / 5)) - barra_paleta));
			}
		}
		else
		{
			for (i = 1; i < tam_upper; i++)
			{
				draw_sprite(buffer,upper[i],(MAX_X - (tile_xy * (5 - (i % 5)))) - 17,tile_xy * ((int)(i / 5)));
			}
		}
	}
	else if (aba == 4)
	{
		if (barra_paleta != 0)
		{
			for (i = (barra_paleta * 5); i < tam_uppest; i++)
			{
				draw_sprite(buffer,uppest[i],(MAX_X - (tile_xy * (5 - (i % 5)))) - 17,tile_xy * (((int)(i / 5)) - barra_paleta));
			}
		}
		else
		{
			for (i = 1; i < tam_uppest; i++)
			{
				draw_sprite(buffer,uppest[i],(MAX_X - (tile_xy * (5 - (i % 5)))) - 17,tile_xy * ((int)(i / 5)));
			}
		}
	}
}

void barra_pressed (void)
{
	// Teste do Butao UP da paleta
	if (mouse_b == 1)
	{
		if (
				((mouse_x > (MAX_X - button_xy)) && (mouse_x < MAX_X)) &&
				((mouse_y > 0) && (mouse_y < button_xy))
		   )
		{
			if (barra_paleta > 0)
			{
				draw_sprite(buffer,up_button_p,(MAX_X - button_xy),0);
				barra_paleta--;
			}
			else
			{
				draw_sprite(buffer,up_button_unp,(MAX_X - button_xy),0);
			}
		}
		else
		{
			draw_sprite(buffer,up_button_unp,(MAX_X - button_xy),0);
		}

		// Teste do Butao DOWN da paleta
		if (
				((mouse_x > (MAX_X - button_xy)) && (mouse_x < MAX_X)) &&
				((mouse_y > ((10 * tile_xy) - button_xy)) && (mouse_y < (10 * tile_xy)))

		   )
		{
			switch (aba)
			{
				case 0:
					if (tam_tiles >= 50 && barra_paleta < (((int)((tam_tiles - 50) / 5)) + 1))
					{
						draw_sprite(buffer,down_button_p,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
						barra_paleta++;
					}
					else
					{
						draw_sprite(buffer,down_button_unp,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
					}
					break;
				case 1:
					if (tam_lower >= 50 && barra_paleta < (((int)((tam_lower - 50) / 5)) + 1))
					{
						draw_sprite(buffer,down_button_p,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
						barra_paleta++;
					}
					else
					{
						draw_sprite(buffer,down_button_unp,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
					}
					break;
				case 2:
					if (tam_objects >= 50 && barra_paleta < (((int)((tam_objects - 50) / 5)) + 1))
					{
						draw_sprite(buffer,down_button_p,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
						barra_paleta++;
					}
					else
					{
						draw_sprite(buffer,down_button_unp,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
					}
					break;
				case 3:
					if (tam_upper >= 50 && barra_paleta < (((int)((tam_upper - 50) / 5)) + 1))
					{
						draw_sprite(buffer,down_button_p,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
						barra_paleta++;
					}
					else
					{
						draw_sprite(buffer,down_button_unp,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
					}
					break;
				case 4:
					if (tam_uppest >= 50 && barra_paleta < (((int)((tam_uppest - 50) / 5)) + 1))
					{
						draw_sprite(buffer,down_button_p,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
						barra_paleta++;
					}
					else
					{
						draw_sprite(buffer,down_button_unp,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
					}
					break;
			}
		}
		else
		{
			draw_sprite(buffer,down_button_unp,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
		}

		// Teste do Botao UP do mapa
		if (
				((mouse_x > (10 * tile_xy)) && (mouse_x < ((10 * tile_xy) + button_xy))) &&
				((mouse_y > 0) && (mouse_y < button_xy))
		   )
		{
			if (barra_map_ud > 0)
			{
				barra_map_ud--;
				draw_sprite(buffer,up_button_p,(10 * tile_xy),0);
			}
			else
			{
				draw_sprite(buffer,up_button_unp,(10 * tile_xy),0);
			}
		}
		else
		{
			draw_sprite(buffer,up_button_unp,(10 * tile_xy),0);
		}

		// Teste do Botao DOWN do mapa
		if (
				((mouse_x > (10 * tile_xy)) && (mouse_x < ((10 * tile_xy) + button_xy))) &&
				((mouse_y > ((10 * tile_xy) - button_xy) - 1) && (mouse_y < ((10 * tile_xy) - 1)))
		   )
		{
			if (barra_map_ud < (map_y - 10))
			{
				barra_map_ud++;
				draw_sprite(buffer,down_button_p,(10 * tile_xy),((10 * tile_xy) - button_xy) - 1);
			}
			else
			{
				draw_sprite(buffer,down_button_unp,(10 * tile_xy),((10 * tile_xy) - button_xy) - 1);
			}
		}
		else
		{
			draw_sprite(buffer,down_button_unp,(10 * tile_xy),((10 * tile_xy) - button_xy) - 1);
		}

		// Teste do Botao LEFT do mapa
		if (
				((mouse_x > 0) && (mouse_x < button_xy)) &&
				((mouse_y > (10 * tile_xy)) && (mouse_y < ((10 * tile_xy) + button_xy)))
		   )
		{
			if (barra_map_lr > 0)
			{
				barra_map_lr--;
				draw_sprite(buffer,left_button_p,0,(10 * tile_xy));
			}
			else
			{
				draw_sprite(buffer,left_button_unp,0,(10 * tile_xy));
			}
		}
		else
		{
			draw_sprite(buffer,left_button_unp,0,(10 * tile_xy));
		}

		// Teste do Botao RIGHT do mapa
		if (
				((mouse_x > ((10 * tile_xy) - button_xy)) && (mouse_x < (10 * tile_xy))) &&
				((mouse_y > (10 * tile_xy)) && (mouse_y < (10 * tile_xy) + button_xy))
		   )
		{
			if (barra_map_lr < (map_x - 10))
			{
				barra_map_lr++;
				draw_sprite(buffer,right_button_p,((10 * tile_xy) - button_xy),(10 * tile_xy));
			}
			else
			{
				draw_sprite(buffer,right_button_unp,((10 * tile_xy) - button_xy),(10 * tile_xy));
			}

		}
		else
		{
			draw_sprite(buffer,right_button_unp,((10 * tile_xy) - button_xy),(10 * tile_xy));
		}
	}
	else
	{
		draw_sprite(buffer,up_button_unp,(MAX_X - button_xy),0);
		draw_sprite(buffer,down_button_unp,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
		draw_sprite(buffer,up_button_unp,(10 * tile_xy),0);
		draw_sprite(buffer,down_button_unp,(10 * tile_xy),((10 * tile_xy) - button_xy) - 1);
		draw_sprite(buffer,left_button_unp,0,(10 * tile_xy));
		draw_sprite(buffer,right_button_unp,((10 * tile_xy) - button_xy),(10 * tile_xy));
	}
}

void load_interface (void)
{
	frame = load_bitmap("sprites/interface/frame.bmp",NULL);
	intro = load_bitmap("sprites/interface/intro.bmp",NULL);

	cursor = load_bitmap("sprites/interface/cursor.bmp",NULL);
	mouse = load_bitmap("sprites/interface/mouse.bmp",NULL);

	right_button_p = load_bitmap("sprites/interface/button_right_p.bmp",NULL);
	right_button_unp = load_bitmap("sprites/interface/button_right_unp.bmp",NULL);

	left_button_p = load_bitmap("sprites/interface/button_left_p.bmp",NULL);
	left_button_unp = load_bitmap("sprites/interface/button_left_unp.bmp",NULL);

	up_button_p = load_bitmap("sprites/interface/button_up_p.bmp",NULL);
	up_button_unp = load_bitmap("sprites/interface/button_up_unp.bmp",NULL);

	down_button_p = load_bitmap("sprites/interface/button_down_p.bmp",NULL);
	down_button_unp = load_bitmap("sprites/interface/button_down_unp.bmp",NULL);

	bar_ud = load_bitmap("sprites/interface/bar_ud.bmp",NULL);
	bar_lr = load_bitmap("sprites/interface/bar_lr.bmp",NULL);

	aba_tiles_p = load_bitmap("sprites/interface/aba_tiles02.bmp",NULL);
	aba_tiles_unp = load_bitmap("sprites/interface/aba_tiles01.bmp",NULL);
	aba_lower_p = load_bitmap("sprites/interface/aba_lower02.bmp",NULL);
	aba_lower_unp = load_bitmap("sprites/interface/aba_lower01.bmp",NULL);
	aba_objects_p = load_bitmap("sprites/interface/aba_objects02.bmp",NULL);
	aba_objects_unp = load_bitmap("sprites/interface/aba_objects01.bmp",NULL);
	aba_upper_p = load_bitmap("sprites/interface/aba_upper02.bmp",NULL);
	aba_upper_unp = load_bitmap("sprites/interface/aba_upper01.bmp",NULL);
	aba_uppest_p = load_bitmap("sprites/interface/aba_uppest02.bmp",NULL);
	aba_uppest_unp = load_bitmap("sprites/interface/aba_uppest01.bmp",NULL);

	menu_save = load_bitmap("sprites/interface/button_save.bmp",NULL);
	menu_load = load_bitmap("sprites/interface/button_load.bmp",NULL);
	menu_exit = load_bitmap("sprites/interface/button_exit.bmp",NULL);
	menu_help = load_bitmap("sprites/interface/button_help.bmp",NULL);
	menu_new = load_bitmap("sprites/interface/button_new.bmp",NULL);

	save_box = load_bitmap("sprites/interface/save_box.bmp",NULL);
	load_box = load_bitmap("sprites/interface/load_box.bmp",NULL);
	resize_box = load_bitmap("sprites/interface/resize_box.bmp",NULL);
	confirm_box = load_bitmap("sprites/interface/confirm_box.bmp",NULL);
}

void draw_map (void)
{
	int i,j;

	for (i = 0; i < map_x; i++)
	{
		for (j = 0; j < map_y; j++)
		{
			if (map_tiles[i][j] != 0 && map_tiles[i][j] < tam_tiles)
			{
				draw_sprite(map_buffer,tiles[map_tiles[i][j]],(i * tile_xy),(j * tile_xy));
			}
		}
	}

	for (i = 0; i < map_x; i++)
	{
		for (j = 0; j < map_y; j++)
		{
			if (map_lower[i][j] != 0 && map_lower[i][j] < tam_lower)
			{
				draw_sprite(map_buffer,lower[map_lower[i][j]],(i * tile_xy),(j * tile_xy));
			}
		}
	}

	for (i = 0; i < map_x; i++)
	{
		for (j = 0; j < map_y; j++)
		{
			if (map_objects[i][j] != 0 && map_objects[i][j] < tam_objects)
			{
				draw_sprite(map_buffer,objects[map_objects[i][j]],(i * tile_xy),(j * tile_xy));
			}
		}
	}

	for (i = 0; i < map_x; i++)
	{
		for (j = 0; j < map_y; j++)
		{
			if (map_upper[i][j] != 0 && map_upper[i][j] < tam_upper)
			{
				draw_sprite(map_buffer,upper[map_upper[i][j]],(i * tile_xy),(j * tile_xy));
			}
		}
	}

	for (i = 0; i < map_x; i++)
	{
		for (j = 0; j < map_y; j++)
		{
			if (map_uppest[i][j] != 0 && map_uppest[i][j] < tam_uppest)
			{
				draw_sprite(map_buffer,uppest[map_uppest[i][j]],(i * tile_xy),(j * tile_xy));
			}
		}
	}
}

void new_map (int x, int y)
{
	int i,j;

	//Malocando e zerando matrizes do novo mapa
	map_tiles = (int **)malloc(sizeof(int *) * x);
	for (i = 0; i < x; i++)
	{
		map_tiles[i] = (int *)malloc(sizeof(int) * y);
	}

	map_lower = (int **)malloc(sizeof(int *) * x);
	for (i = 0; i < x; i++)
	{
		map_lower[i] = (int *)malloc(sizeof(int) * y);
	}

	map_objects = (int **)malloc(sizeof(int *) * x);
	for (i = 0; i < x; i++)
	{
		map_objects[i] = (int *)malloc(sizeof(int) * y);
	}

	map_upper = (int **)malloc(sizeof(int *) * x);
	for (i = 0; i < x; i++)
	{
		map_upper[i] = (int *)malloc(sizeof(int) * y);
	}

	map_uppest = (int **)malloc(sizeof(int *) * x);
	for (i = 0; i < x; i++)
	{
		map_uppest[i] = (int *)malloc(sizeof(int) * y);
	}

	for (i = 0; i < x; i++)
	{
		for (j = 0; j < y; j++)
		{
			map_tiles[i][j] = 0;
		}
	}

	for (i = 0; i < x; i++)
	{
		for (j = 0; j < y; j++)
		{
			map_lower[i][j] = 0;
		}
	}

	for (i = 0; i < x; i++)
	{
		for (j = 0; j < y; j++)
		{
			map_objects[i][j] = 0;
		}
	}

	for (i = 0; i < x; i++)
	{
		for (j = 0; j < y; j++)
		{
			map_upper[i][j] = 0;
		}
	}

	for (i = 0; i < x; i++)
	{
		for (j = 0; j < y; j++)
		{
			map_uppest[i][j] = 0;
		}
	}
}

void save_map (void)
{
	int i,j;

	if (get_name(0))
	{
		printf("get_file succeeded\n");
		printf("Nome no save: %s\n",nome);
		if ((parq = fopen (nome, "wb")) == NULL)
		{
			printf("Desculpe, o arquivo nao pode ser aberto para escrita.");
		}

		rewind(parq);
		
		fwrite(&map_x,sizeof(int),1,parq);
		fwrite(&map_y,sizeof(int),1,parq);

		for (i = 0; i < map_x; i++)
		{
			for (j = 0; j < map_y; j++)
			{
				fwrite(&map_tiles[i][j],sizeof(int),1,parq);
			}
		}

		for (i = 0; i < map_x; i++)
		{
			for (j = 0; j < map_y; j++)
			{
				fwrite(&map_lower[i][j],sizeof(int),1,parq);
			}
		}

		for (i = 0; i < map_x; i++)
		{
			for (j = 0; j < map_y; j++)
			{
				fwrite(&map_objects[i][j],sizeof(int),1,parq);
			}
		}

		for (i = 0; i < map_x; i++)
		{
			for (j = 0; j < map_y; j++)
			{
				fwrite(&map_upper[i][j],sizeof(int),1,parq);
			}
		}

		for (i = 0; i < map_x; i++)
		{
			for (j = 0; j < map_y; j++)
			{
				fwrite(&map_uppest[i][j],sizeof(int),1,parq);
			}
		}

		fclose(parq);
	}
	printf("End of get_file\n");
}

void load_map (void)
{
	int i,j;

	if (get_name(1))
	{
		printf("get_file succeeded\n");
		printf("Nome no load: %s\n",nome);
		if ((parq = fopen (nome, "rb")) == NULL)
		{
			printf("Desculpe, o arquivo nao pode ser aberto para escrita.");
		}

		rewind(parq);
		
		fread(&map_x,sizeof(int),1,parq);
		fread(&map_y,sizeof(int),1,parq);
		
		new_map(map_x,map_y);

		for (i = 0; i < map_x; i++)
		{
			for (j = 0; j < map_y; j++)
			{
				fread(&map_tiles[i][j],sizeof(int),1,parq);
			}
		}

		for (i = 0; i < map_x; i++)
		{
			for (j = 0; j < map_y; j++)
			{
				fread(&map_lower[i][j],sizeof(int),1,parq);
			}
		}

		for (i = 0; i < map_x; i++)
		{
			for (j = 0; j < map_y; j++)
			{
				fread(&map_objects[i][j],sizeof(int),1,parq);
			}
		}

		for (i = 0; i < map_x; i++)
		{
			for (j = 0; j < map_y; j++)
			{
				fread(&map_upper[i][j],sizeof(int),1,parq);
			}
		}

		for (i = 0; i < map_x; i++)
		{
			for (j = 0; j < map_y; j++)
			{
				fread(&map_uppest[i][j],sizeof(int),1,parq);
			}
		}

		fclose(parq);
		printf("End of get_file\n");
	}
}

void resize_map (void)
{

}

void move_cursor (void)
{
	int i;

	if (mouse_b == 1)
	{
		for (i = 0; i < 50; i++)
		{
			if (
					((mouse_x > (MAX_X - ((5 - (i % 5)) * tile_xy)) - button_xy) && (mouse_x < ((MAX_X - ((5 - (i % 5)) * tile_xy)) + tile_xy) - button_xy)) &&
					((mouse_y > ((((int)(i / 5)) % 50) * tile_xy)) && (mouse_y < (((((int)(i / 5)) % 50) * tile_xy)) + tile_xy))
			   )
			{
				selected = i + (barra_paleta * 5);
			}
		}
	}
}

void draw (void)
{
	int i,j;

	if (mouse_b == 1)
	{
		switch (aba)
		{
			case 0:
				for (i = 0; i < 10; i++)
				{
					for (j = 0; j < 10; j++)
					{
						if (
							(mouse_x > (i * tile_xy) && mouse_x < ((i * tile_xy) + tile_xy)) &&
							(mouse_y > (j * tile_xy) && mouse_y < ((j * tile_xy) + tile_xy))
						   )
						{
							map_tiles[i + barra_map_lr][j + barra_map_ud] = selected;
						}
					}
				}
				break;
			case 1:
				for (i = 0; i < 10; i++)
				{
					for (j = 0; j < 10; j++)
					{
						if (
							(mouse_x > (i * tile_xy) && mouse_x < ((i * tile_xy) + tile_xy)) &&
							(mouse_y > (j * tile_xy) && mouse_y < ((j * tile_xy) + tile_xy))
						   )
						{
							map_lower[i + barra_map_lr][j + barra_map_ud] = selected;
						}
					}
				}
				break;
			case 2:
				for (i = 0; i < 10; i++)
				{
					for (j = 0; j < 10; j++)
					{
						if (
							(mouse_x > (i * tile_xy) && mouse_x < ((i * tile_xy) + tile_xy)) &&
							(mouse_y > (j * tile_xy) && mouse_y < ((j * tile_xy) + tile_xy))
						   )
						{
							map_objects[i + barra_map_lr][j + barra_map_ud] = selected;
						}
					}
				}
				break;
			case 3:
				for (i = 0; i < 10; i++)
				{
					for (j = 0; j < 10; j++)
					{
						if (
							(mouse_x > (i * tile_xy) && mouse_x < ((i * tile_xy) + tile_xy)) &&
							(mouse_y > (j * tile_xy) && mouse_y < ((j * tile_xy) + tile_xy))
						   )
						{
							map_upper[i + barra_map_lr][j + barra_map_ud] = selected;
						}
					}
				}
				break;
			case 4:
				for (i = 0; i < 10; i++)
				{
					for (j = 0; j < 10; j++)
					{
						if (
							(mouse_x > (i * tile_xy) && mouse_x < ((i * tile_xy) + tile_xy)) &&
							(mouse_y > (j * tile_xy) && mouse_y < ((j * tile_xy) + tile_xy))
						   )
						{
							map_uppest[i + barra_map_lr][j + barra_map_ud] = selected;
						}
					}
				}
				break;
		}
	}
}

void select_aba (void)
{
	if (key[KEY_1])
	{
		aba = 0;
		barra_map_ud = 0;
		barra_map_lr = 0;
		selected = 0;
	}
	if (key[KEY_2])
	{
		aba = 1;
		barra_map_ud = 0;
		barra_map_lr = 0;
		selected = 0;
	}
	if (key[KEY_3])
	{
		aba = 2;
		barra_map_ud = 0;
		barra_map_lr = 0;
		selected = 0;
	}
	if (key[KEY_4])
	{
		aba = 3;
		barra_map_ud = 0;
		barra_map_lr = 0;
		selected = 0;
	}
	if (key[KEY_5])
	{
		aba = 4;
		barra_map_ud = 0;
		barra_map_lr = 0;
		selected = 0;
	}
}

void draw_aba (void)
{
	//Desenha Aba Selecionada
	if (aba == 0)
	{
		draw_sprite(buffer,aba_tiles_p,MAX_X - ((3 * button_xy) + (3 * aba_x)),(10 * tile_xy) + aba_y);
	}
	else
	{
		draw_sprite(buffer,aba_tiles_unp,MAX_X - ((3 * button_xy) + (3 * aba_x)),(10 * tile_xy) + aba_y);
	}

	if (aba == 1)
	{
		draw_sprite(buffer,aba_lower_p,MAX_X - ((2 * button_xy) + (2 * aba_x)),(10 * tile_xy) + aba_y);
	}
	else
	{
		draw_sprite(buffer,aba_lower_unp,MAX_X - ((2 * button_xy) + (2 * aba_x)),(10 * tile_xy) + aba_y);
	}

	if (aba == 2)
	{
		draw_sprite(buffer,aba_objects_p,MAX_X - (button_xy + aba_x),(10 * tile_xy) + aba_y);
	}
	else
	{
		draw_sprite(buffer,aba_objects_unp,MAX_X - (button_xy + aba_x),(10 * tile_xy) + aba_y);
	}

	if (aba == 3)
	{
		draw_sprite(buffer,aba_upper_p,MAX_X - ((3 * button_xy) + ((5 * aba_x) / 2)),(10 * tile_xy) + (2 * aba_y) + button_xy);
	}
	else
	{
		draw_sprite(buffer,aba_upper_unp,MAX_X - ((3 * button_xy) + ((5 * aba_x) / 2)),(10 * tile_xy) + (2 * aba_y) + button_xy);
	}

	if (aba == 4)
	{
		draw_sprite(buffer,aba_uppest_p,MAX_X - ((2 * button_xy) + ((3 * aba_x) / 2)),(10 * tile_xy) + (2 * aba_y) + button_xy);
	}
	else
	{
		draw_sprite(buffer,aba_uppest_unp,MAX_X - ((2 * button_xy) + ((3 * aba_x) / 2)),(10 * tile_xy) + (2 * aba_y) + button_xy);
	}
}

void menu_pressed (void)
{
	int decision = 0;

	if (mouse_b == 1)
	{
		// New Button
		if (
				((mouse_x > 145) && (mouse_x < (145 + menu_button_xy))) &&
				((mouse_y > (11 * tile_xy)) && (mouse_y < ((11 * tile_xy) + menu_button_xy)))
		   )
		{
			alert("CONFIG_FILE", "not found.", "Using defaults.","Continue", "blabla", "c", "a");
			while (!decision)
			{
				clear_to_color(buffer,makecol(255,0,255));
				clear_to_color(map_buffer,makecol(255,0,255));

				// Desenha Paleta no Frame
				draw_pallete();

				// Desenha o Frame
				draw_sprite(buffer,frame,0,0);

				// Desenha Mapa no Buffer do Mapa
				draw_map();

				// Desenha Interface
				draw_aba();

				// Desenha Cursor no Buffer
				if ((selected >= (5 * barra_paleta)) && (selected < ((5 * barra_paleta) + 50)))
				{
					draw_sprite(buffer,cursor,(MAX_X - (tile_xy * (5 - (selected % 5)))) - 17,tile_xy * (((int)(selected / 5)) - barra_paleta));
				}

				// Blita Buffer do Mapa
				blit(map_buffer,buffer,(tile_xy * barra_map_lr),(tile_xy * barra_map_ud),0,0,480,480);
				
				// Buttons do Menu
				draw_sprite(buffer,menu_new,147,(11 * tile_xy) + 2);

				draw_sprite (buffer,menu_save,(150 + menu_button_xy),(11 * tile_xy));
				draw_sprite (buffer,menu_load,(155 + (2 * menu_button_xy)),(11 * tile_xy));
				draw_sprite (buffer,menu_help,(160 + (3 * menu_button_xy)),(11 * tile_xy));
				draw_sprite (buffer,menu_exit,(165 + (4 * menu_button_xy)),(11 * tile_xy));

				// Confirm Box
				draw_sprite(buffer,confirm_box,((MAX_X / 2)  - (confirm_box->w / 2)),((MAX_Y / 2) - (confirm_box->h / 2)));

				// Button da Barra
				draw_sprite(buffer,up_button_unp,(MAX_X - button_xy),0);
				draw_sprite(buffer,down_button_unp,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
				draw_sprite(buffer,up_button_unp,(10 * tile_xy),0);
				draw_sprite(buffer,down_button_unp,(10 * tile_xy),((10 * tile_xy) - button_xy) - 1);
				draw_sprite(buffer,left_button_unp,0,(10 * tile_xy));
				draw_sprite(buffer,right_button_unp,((10 * tile_xy) - button_xy),(10 * tile_xy));
				
				// Desenha Mouse
				draw_sprite(buffer,mouse,mouse_x - 11,mouse_y);

				// Blita Buffer
				blit(buffer,screen,0,0,0,0,MAX_X,MAX_Y);

				if (mouse_b == 1)
				{
					if (
							((mouse_x > ((MAX_X / 2) + 73 - (confirm_box->w / 2))) && (mouse_x < ((MAX_X / 2) + 73 + menu_button_xy - (confirm_box->w / 2)))) &&
							((mouse_y > ((MAX_Y / 2) + 120 - (confirm_box->h / 2))) && (mouse_y < ((MAX_Y / 2) + 120 + menu_button_xy - (confirm_box->h / 2))))
					   )
					{
						map_x = 20;
						map_y = 20;
						barra_paleta = 0;
						barra_map_ud = 0;
						barra_map_lr = 0;
						aba = 0;
						selected = 0;
				
						map_buffer = create_bitmap((tile_xy * map_x),(tile_xy * map_y));
				
						new_map(map_x,map_y);
						
						decision = 1;
					}
					else if (
								((mouse_x > ((MAX_X / 2) + 162 - (confirm_box->w / 2))) && (mouse_x < ((MAX_X / 2) + 162 + menu_button_xy - (confirm_box->w / 2)))) &&
								((mouse_y > ((MAX_Y / 2) + 120 - (confirm_box->h / 2))) && (mouse_y < ((MAX_Y / 2) + 120 + menu_button_xy - (confirm_box->h / 2))))
							)
					{
						decision = 1;
					}
				}
			}
		}
		else
		{
			draw_sprite (buffer,menu_new,145,(11 * tile_xy));
		}

		// Save Button
		if (
				((mouse_x > (150 + menu_button_xy)) && (mouse_x < (150 + (2 * menu_button_xy)))) &&
				((mouse_y > (11 * tile_xy)) && (mouse_y < ((11 * tile_xy) + menu_button_xy)))
		   )
		{
			save_map();
			draw_sprite (buffer,menu_save,(152 + menu_button_xy),(11 * tile_xy) + 2);
		}
		else
		{
			draw_sprite (buffer,menu_save,(150 + menu_button_xy),(11 * tile_xy));
		}

		// Load Button
		if (
				((mouse_x > (155 + (2 * menu_button_xy))) && (mouse_x < (155 + (3 * menu_button_xy)))) &&
				((mouse_y > (11 * tile_xy)) && (mouse_y < ((11 * tile_xy) + menu_button_xy)))
		   )
		{
			load_map();
			draw_sprite (buffer,menu_load,(157 + (2 * menu_button_xy)),(11 * tile_xy) + 2);
		}
		else
		{
			draw_sprite (buffer,menu_load,(155 + (2 * menu_button_xy)),(11 * tile_xy));
		}

		// Help Button
		if (
				((mouse_x > (160 + (3 * menu_button_xy))) && (mouse_x < (160 + (4 * menu_button_xy)))) &&
				((mouse_y > (11 * tile_xy)) && (mouse_y < ((11 * tile_xy) + menu_button_xy)))
		   )
		{
			draw_sprite (buffer,menu_help,(162 + (3 * menu_button_xy)),(11 * tile_xy) + 2);
		}
		else
		{
			draw_sprite (buffer,menu_help,(160 + (3 * menu_button_xy)),(11 * tile_xy));
		}

		// Exit Button
		if (
				((mouse_x > (165 + (4 * menu_button_xy))) && (mouse_x < (165 + (5 * menu_button_xy)))) &&
				((mouse_y > (11 * tile_xy)) && (mouse_y < ((11 * tile_xy) + menu_button_xy)))
		   )
		{
			while (!decision)
			{
				clear_to_color(buffer,makecol(255,0,255));
				clear_to_color(map_buffer,makecol(255,0,255));

				// Desenha Paleta no Frame
				draw_pallete();

				// Desenha o Frame
				draw_sprite(buffer,frame,0,0);

				// Desenha Mapa no Buffer do Mapa
				draw_map();

				// Desenha Interface
				draw_aba();

				// Desenha Cursor no Buffer
				if ((selected >= (5 * barra_paleta)) && (selected < ((5 * barra_paleta) + 50)))
				{
					draw_sprite(buffer,cursor,(MAX_X - (tile_xy * (5 - (selected % 5)))) - 17,tile_xy * (((int)(selected / 5)) - barra_paleta));
				}

				// Blita Buffer do Mapa
				blit(map_buffer,buffer,(tile_xy * barra_map_lr),(tile_xy * barra_map_ud),0,0,480,480);
				
				// Buttons do Menu
				draw_sprite (buffer,menu_exit,(167 + (4 * menu_button_xy)),(11 * tile_xy) + 2);

				draw_sprite (buffer,menu_new,145,(11 * tile_xy));
				draw_sprite (buffer,menu_save,(150 + menu_button_xy),(11 * tile_xy));
				draw_sprite (buffer,menu_load,(155 + (2 * menu_button_xy)),(11 * tile_xy));
				draw_sprite (buffer,menu_help,(160 + (3 * menu_button_xy)),(11 * tile_xy));

				// Confirm Box
				draw_sprite(buffer,confirm_box,((MAX_X / 2)  - (confirm_box->w / 2)),((MAX_Y / 2) - (confirm_box->h / 2)));

				// Button da Barra
				draw_sprite(buffer,up_button_unp,(MAX_X - button_xy),0);
				draw_sprite(buffer,down_button_unp,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
				draw_sprite(buffer,up_button_unp,(10 * tile_xy),0);
				draw_sprite(buffer,down_button_unp,(10 * tile_xy),((10 * tile_xy) - button_xy) - 1);
				draw_sprite(buffer,left_button_unp,0,(10 * tile_xy));
				draw_sprite(buffer,right_button_unp,((10 * tile_xy) - button_xy),(10 * tile_xy));
				
				// Desenha Mouse
				draw_sprite(buffer,mouse,mouse_x - 11,mouse_y);

				// Blita Buffer
				blit(buffer,screen,0,0,0,0,MAX_X,MAX_Y);

				if (mouse_b == 1)
				{
					if (
							((mouse_x > ((MAX_X / 2) + 73 - (confirm_box->w / 2))) && (mouse_x < ((MAX_X / 2) + 73 + menu_button_xy - (confirm_box->w / 2)))) &&
							((mouse_y > ((MAX_Y / 2) + 120 - (confirm_box->h / 2))) && (mouse_y < ((MAX_Y / 2) + 120 + menu_button_xy - (confirm_box->h / 2))))
					   )
					{
						sair = 1;
						decision = 1;
					}
					else if (
								((mouse_x > ((MAX_X / 2) + 162 - (confirm_box->w / 2))) && (mouse_x < ((MAX_X / 2) + 162 + menu_button_xy - (confirm_box->w / 2)))) &&
								((mouse_y > ((MAX_Y / 2) + 120 - (confirm_box->h / 2))) && (mouse_y < ((MAX_Y / 2) + 120 + menu_button_xy - (confirm_box->h / 2))))
							)
					{
						decision = 1;
					}
				}
			}
		}
		else
		{
			draw_sprite (buffer,menu_exit,(165 + (4 * menu_button_xy)),(11 * tile_xy));
		}
	}
	else
	{
		draw_sprite (buffer,menu_new,145,(11 * tile_xy));
		draw_sprite (buffer,menu_save,(150 + menu_button_xy),(11 * tile_xy));
		draw_sprite (buffer,menu_load,(155 + (2 * menu_button_xy)),(11 * tile_xy));
		draw_sprite (buffer,menu_help,(160 + (3 * menu_button_xy)),(11 * tile_xy));
		draw_sprite (buffer,menu_exit,(165 + (4 * menu_button_xy)),(11 * tile_xy));
	}
}

int get_file (int controle)
{
	int tecla;
	
	while (!decision)
	{
		clear_to_color(buffer,makecol(255,0,255));
		clear_to_color(map_buffer,makecol(255,0,255));

		// Desenha Paleta no Frame
		draw_pallete();

		// Desenha o Frame
		draw_sprite(buffer,frame,0,0);

		// Desenha Mapa no Buffer do Mapa
		draw_map();

		// Desenha Interface
		draw_aba();

		// Desenha Cursor no Buffer
		if ((selected >= (5 * barra_paleta)) && (selected < ((5 * barra_paleta) + 50)))
		{
			draw_sprite(buffer,cursor,(MAX_X - (tile_xy * (5 - (selected % 5)))) - 17,tile_xy * (((int)(selected / 5)) - barra_paleta));
		}

		// Blita Buffer do Mapa
		blit(map_buffer,buffer,(tile_xy * barra_map_lr),(tile_xy * barra_map_ud),0,0,480,480);
		
		// Buttons do Menu
		
		draw_sprite (buffer,menu_exit,(165 + (4 * menu_button_xy)),(11 * tile_xy));
		draw_sprite (buffer,menu_new,145,(11 * tile_xy));
		draw_sprite (buffer,menu_help,(160 + (3 * menu_button_xy)),(11 * tile_xy));
		
		if (controle)
		{
			draw_sprite (buffer,menu_save,(152 + menu_button_xy),(11 * tile_xy) + 2);
			draw_sprite (buffer,menu_load,(155 + (2 * menu_button_xy)),(11 * tile_xy));
		}
		else
		{
			draw_sprite (buffer,menu_save,(150 + menu_button_xy),(11 * tile_xy));
			draw_sprite (buffer,menu_load,(157 + (2 * menu_button_xy)),(11 * tile_xy) + 2);
		}

		// Button da Barra
		draw_sprite(buffer,up_button_unp,(MAX_X - button_xy),0);
		draw_sprite(buffer,down_button_unp,(MAX_X - button_xy),((10 * tile_xy) - button_xy) - 1);
		draw_sprite(buffer,up_button_unp,(10 * tile_xy),0);
		draw_sprite(buffer,down_button_unp,(10 * tile_xy),((10 * tile_xy) - button_xy) - 1);
		draw_sprite(buffer,left_button_unp,0,(10 * tile_xy));
		draw_sprite(buffer,right_button_unp,((10 * tile_xy) - button_xy),(10 * tile_xy));
		
		// Desenha Mouse
		draw_sprite(buffer,mouse,mouse_x - 11,mouse_y);

		// Blita Buffer
		blit(buffer,screen,0,0,0,0,MAX_X,MAX_Y);

		if (keypressed())
		{
			tecla = readkey();
			
		}
		
		if (mouse_b == 1)
		{
			if (
					((mouse_x > ((MAX_X / 2) + 73 - (confirm_box->w / 2))) && (mouse_x < ((MAX_X / 2) + 73 + menu_button_xy - (confirm_box->w / 2)))) &&
					((mouse_y > ((MAX_Y / 2) + 120 - (confirm_box->h / 2))) && (mouse_y < ((MAX_Y / 2) + 120 + menu_button_xy - (confirm_box->h / 2))))
			   )
			{
				sair = 1;
				decision = 1;
			}
			else if (
						((mouse_x > ((MAX_X / 2) + 162 - (confirm_box->w / 2))) && (mouse_x < ((MAX_X / 2) + 162 + menu_button_xy - (confirm_box->w / 2)))) &&
						((mouse_y > ((MAX_Y / 2) + 120 - (confirm_box->h / 2))) && (mouse_y < ((MAX_Y / 2) + 120 + menu_button_xy - (confirm_box->h / 2))))
					)
			{
				decision = 1;
			}
		}
	}
}

#include "allegro_init.h"
